Scriptname zz01SCRPTCheeseChurn extends ObjectReference  


Import Utility
Import Game
Import Debug

sound property ChurningUpSound auto
{Find a sound to play once per second while pulling handle up}

sound property ChurningDownSound auto
{Find a sound to play once per second while pushing handle down}

ObjectReference Property Handle Auto
{Connect this to the handle/hoe}
ObjectReference Property HandleUpX Auto
{Connect this to the topmost XMarker}
ObjectReference Property HandleDownX Auto
{Connect this to the bottom XMarker}
ObjectReference Property OffBox Auto
{The collision box around the trigger to stop players from activating the churn while it's running. the box MUST be set to "Initially Disabled" in the ck!!!}
Int Property AddHowManyPotMilk Auto
{How many milk-as-potions you need per cheese}

Int Property AddHowManyIng01 Auto
{How many ingredients you need for custom cheese 01}
Int Property AddHowManyIng02 Auto
{How many ingredients you need for custom cheese 02}
Int Property AddHowManyIng03 Auto
{How many ingredients you need for custom cheese 03}

Int Property HowManyEiderUGet Auto
{Add the number of Eidar cheese you get}

Int Property HowManyCustom01UGet Auto
{Add the number of custom cheese 01 you get}
Int Property HowManyCustom02UGet Auto
{Add the number of custom cheese 02 you get}
Int Property HowManyCustom03UGet Auto
{Add the number of custom cheese 03 you get}

Int HowManyCurrentIng
Int CurrentHowManyUGet
Int ShouldCheckIng = 0
Int CurrentIngCheck
Int Coninue = 1

Potion Property FoodCheeseWheel02A Auto
{Auto-Fill for Eidar Cheese Wheel}

Potion Property CustomCheese01 Auto
{Add custom cheese 01 here}
Potion Property CustomCheese02 Auto
{Add custom cheese 02 here}
Potion Property CustomCheese03 Auto
{Add custom cheese 03 here}

Potion CurrentCheese

Formlist Property FLSTMilk Auto
{Make a formlist that contains just the milk and connect it here}

Formlist Property Cheese01Ingredient Auto
{Make a formlist that contains just the added ingredient for custom cheese 01 and connect it here}
Formlist Property Cheese02Ingredient Auto
{Make a formlist that contains just the added ingredient for custom cheese 02 and connect it here}
Formlist Property Cheese03Ingredient Auto
{Make a formlist that contains just the added ingredient for custom cheese 03 and connect it here}

Formlist CurrentIng

String Property YouAintGotEnoughMilk Auto
{Message to be shown when you ain't got enough milk}
String Property YouAintGotEnoughIng Auto
{Message to be shown when you ain't got enough ingredients}
String Property MilkRemoved Auto
{Add the notification of what, and how many of this item was removed from the player, eg: 2 Milk Removed}
String Property Ingredient01Removed Auto
{Add the notification of what, and how many of this item was removed from the player, eg: 4 Red Mountain Flower Removed}
String Property Ingredient02Removed Auto
{Add the notification of what, and how many of this item was removed from the player, eg: 4 Blue Mountain Flower Removed}
String Property Ingredient03Removed Auto
{Add the notification of what, and how many of this item was removed from the player, eg: 4 Purple Mountain Flower Removed}
String Property HowManyEiderUGot Auto
{Add the notification of what, and how many of this item was added to the player, eg: 1 Eidar Cheese Wheel Added}
String Property HowManyCustom01UGot Auto
{Add the notification of what, and how many of this item was added to the player, eg: 1 Red Mountain Cheese Lite Added}
String Property HowManyCustom02UGot Auto
{Add the notification of what, and how many of this item was added to the player, eg: 1 Blue Mountain Cheese Lite Added}
String Property HowManyCustom03UGot Auto
{Add the notification of what, and how many of this item was added to the player, eg: 1 Purple Mountain Cheese Lite Added}

String WhatIngTaken
String CurrentGet

Message Property MSGBXMakeCheese Auto
{Add the options message box here}

;--------------------------------------------------------------------------------------------------
Event OnActivate(Objectreference obj)

Actor Player = GetPlayer()

Int Ing01Check = Player.GetItemCount(Cheese01Ingredient)
Int Ing02Check = Player.GetItemCount(Cheese02Ingredient)
Int Ing03Check = Player.GetItemCount(Cheese03Ingredient)

Int Button = MSGBXMakeCheese.Show()

If Button == 0
CurrentCheese = FoodCheeseWheel02A
CurrentHowManyUGet = HowManyEiderUGet
CurrentGet = HowManyEiderUGot
WhatIngTaken = ""
ShouldCheckIng = 0
Return CheckMilk()
		
ElseIf Button == 1
CurrentCheese = CustomCheese01
CurrentIng = Cheese01Ingredient
HowManyCurrentIng = AddHowManyIng01
CurrentIngCheck = Ing01Check
CurrentHowManyUGet = HowManyCustom01UGet
CurrentGet = HowManyCustom01UGot
WhatIngTaken = Ingredient01Removed
ShouldCheckIng = 1
Return CheckMilk()

ElseIf Button == 2
CurrentCheese = CustomCheese02
CurrentIng = Cheese02Ingredient
HowManyCurrentIng = AddHowManyIng02
CurrentIngCheck = Ing02Check
CurrentHowManyUGet = HowManyCustom02UGet
CurrentGet = HowManyCustom02UGot
WhatIngTaken = Ingredient02Removed
ShouldCheckIng = 1
Return CheckMilk()

ElseIf Button == 3
CurrentCheese = CustomCheese03
CurrentIng = Cheese03Ingredient
HowManyCurrentIng = AddHowManyIng03
CurrentIngCheck = Ing03Check
CurrentHowManyUGet = HowManyCustom03UGet
CurrentGet = HowManyCustom03UGot
WhatIngTaken = Ingredient03Removed
ShouldCheckIng = 1
Return CheckMilk()

ElseIf Button == 4
EndIf

EndEvent

;---------------------------------------------------------------------------------------------------

Function CheckMilk()

Actor Player = GetPlayer()

Int MilkCheck = Player.GetItemCount(FLSTMilk)

If MilkCheck < AddHowManyPotMilk
Notification(YouAintGotEnoughMilk)
Else 
Return CheckIng()
EndIf

EndFunction

;---------------------------------------------------------------------------------------------------

Function CheckIng()

If ShouldCheckIng == 1
	If CurrentIngCheck < HowManyCurrentIng
	Notification(YouAintGotEnoughIng)
	Else
	Return RunChurn()
	EndIf
Else
Return RunChurn()
EndIf

EndFunction

;----------------------------------------------------------------------------------------------------

Function RunChurn()

Actor Player = GetPlayer()

Notification(MilkRemoved)
Notification(WhatIngTaken)

OffBox.Enable()

Handle.TranslateToRef(HandleUpX, 15.0)
int instanceIDUp01 = ChurningUpSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDUp01)
Handle.TranslateToRef(HandleDownX, 15.0)
int instanceIDDown01 = ChurningDownSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDDown01)
Handle.TranslateToRef(HandleUpX, 15.0)
int instanceIDUp02 = ChurningUpSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDUp02)
Handle.TranslateToRef(HandleDownX, 15.0)
int instanceIDDown02 = ChurningDownSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDDown02)
Handle.TranslateToRef(HandleUpX, 15.0)
int instanceIDUp03 = ChurningUpSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDUp03)
Handle.TranslateToRef(HandleDownX, 15.0)
int instanceIDDown03 = ChurningDownSound.play(self)
Utility.Wait(1.0)
Sound.StopInstance(instanceIDDown03)
Self.Reset()
Handle.Reset()

Player.AddItem(CurrentCheese, CurrentHowManyUGet, True)
Notification(CurrentGet)

OffBox.Disable()

EndFunction
