Scriptname zz01SCRPTMaturing03Maturing extends ObjectReference  


Import Game
Import Utility
Import Debug
Import Math

String Property DaystoWait Auto
{Select amount of days to wait between maturing stages, e.g 1.00, 2.00 etc.}

float property lastHarvestedDay auto Hidden
{the game day this was last successfuly harvested, used to know when to respawn}

Formlist Property FLSTCurrentStaticSet Auto
{Place statics formlist for this current potion type, must have phantom static first!!!}

ObjectReference Static2Switch2

Potion Property CurrentPotion Auto
{Potion to be added to player if this object is taken}

Int Property INTNextStage Auto
{Next stage of maturing, eg, if this is stage 1 this must be "2"}

Int FirstLoad = 1
Int DaysWaited



;===================================================================
;;STATE BLOCK
;===================================================================

auto state readyForHarvest
	event onActivate(objectReference akActivator)
		goToState("waitingToRespawn")
		fakeHarvest(akActivator)
	endEvent
endState

;--------------------------------------------------------------------------
state waitingToRespawn
	event onBeginState()
		lastHarvestedDay = utility.getCurrentGameTime()
	endEvent

;--------------------------------------------------------------------------
	event onActivate(objectReference akActivator)

Actor Player = Game.GetPlayer()

Player.AddItem(CurrentPotion, 1, True)
Static2Switch2 = Self.PlaceAtMe(FLSTCurrentStaticSet.GetAt(0))
Self.Disable()
Self.Delete()

	endEvent

;---------------------------------------------------------------------------
	event onCellLoad()
Float FLTDaysWaited = DaysToWait as Float
Float TwoDays = 2
Float ThreeDays = 3
Float FLTDaysToWait = (FltDaysWaited * TwoDays)
Float FLTDaysToWait2 = (FltDaysWaited * ThreeDays)
		Utility.Wait(1.0)

		if (lastHarvestedDay + FLTDaysToWait2) <= utility.getCurrentGameTime()
		INTNextStage += 2
		SwitchEmOut()
		Elseif (lastHarvestedDay + FLTDaysToWait) <= utility.getCurrentGameTime()
		INTNextStage += 1
		SwitchEmOut()
		Elseif (lastHarvestedDay + DaysToWait) <= utility.getCurrentGameTime()
		SwitchEmOut()
		EndIf

	endEvent
endState

;===================================================================
;;FUNCTION BLOCK
;===================================================================

Function SwitchEmOut()

If INTNextStage > 4
INTNextStage = 4
Else
EndIf

Static2Switch2 = Self.PlaceAtMe(FLSTCurrentStaticSet.GetAt(INTNextStage))
Static2Switch2.Activate(Self)
Self.Disable()
Self.Delete()


EndFunction

;-----------------------------------------------------------------------------
function fakeHarvest(objectReference akActivator)

If FirstLoad == 0

Actor Player = Game.GetPlayer()

Player.AddItem(CurrentPotion, 1, True)
Static2Switch2 = Self.PlaceAtMe(FLSTCurrentStaticSet.GetAt(0))
Static2Switch2.Activate(Self)
Self.Disable()
Self.Delete()
Else
FirstLoad = 0
EndIf

EndFunction


